##
## Copyright (c) 2006 Jason Dillon
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##

##
## $Id: //guest/jason_dillon/p4spam/main/testsuite/testsuite.py#3 $ $Date: 2006/04/12 $
##

import unittest, getopt, sys

from perforce import logging

import test_commands
import test_parser

def suite():
    alltests = unittest.TestSuite(
        (
            unittest.TestLoader().loadTestsFromModule(test_commands),
            unittest.TestLoader().loadTestsFromModule(test_parser),
        )
    )
    
    return alltests

def usage():
    print """usage: %s [-h|--help|-v|--verbose|--debug|--trace]""" % (sys.argv[0])

def main(args):
    try:
        opts, args = getopt.getopt(args, "hv", ["help", "verbose", "debug", "trace"])
    except getopt.GetoptError:
        # print help information and exit:
        usage()
        sys.exit(2)
    
    verbose = 1
    
    for o, a in opts:
        if o in ("-d", "--debug"):
            logging.DEBUG_ENABLED = True
        
        if o in ("-d", "--trace"):
            logging.TRACE_ENABLED = True
        
        if o in ("-v", "--verbose"):
            verbose = 2
        
        if o in ("-h", "--help"):
            usage()
            sys.exit()
        
    s = suite()
    unittest.TextTestRunner(verbosity=verbose).run(s)
